<?php

class TapLoginUser
{	
	public static function GetUserByAzidId($employee_id)
	{
		global $DB;
		$employee_id = intval($employee_id);
		
		if (!$employee_id)
			return false;
		
		$res = $DB->Query("SELECT * FROM b_taplogin_user WHERE AZID_ID = '".$employee_id."'", false, "File: ".__FILE__."<br>Line: ".__LINE__);
		
		return $res;
	}
	
	public static function isUserAttached($USER_ID)
	{
		global $DB, $USER;
		$USER_ID = intval($USER_ID);
		if (!$USER->IsAuthorized() || $USER_ID <= 0)
			return false;
		
		$bIsUserAttached = false;
		
		$rsIsUserAttached = $DB->query("SELECT USER_ID FROM b_taplogin_user WHERE USER_ID = ".$USER_ID, false, "File: ".__FILE__."<br>Line: ".__LINE__);

		$bIsUserAttached = ($rsIsUserAttached->SelectedRowsCount() > 0) ? true : false;
		
		return $bIsUserAttached;
	}
	
	public static function UserAttach($USER_ID, $AZID_ID)
	{
		global $DB, $USER;
		$USER_ID = intval($USER_ID);
		$AZID_ID = intval($AZID_ID);
		if (!$USER->IsAuthorized() || $USER_ID <= 0 || $AZID_ID <= 0 || $USER->GetID() != $USER_ID)
			return false;
		
		$bIsUserAttached = self::isUserAttached($USER_ID);
		
		if ($bIsUserAttached)
		{
			$rsTapLoginUser = $DB->query("SELECT AZID_ID FROM b_taplogin_user WHERE USER_ID = ".$USER_ID, false, "File: ".__FILE__."<br>Line: ".__LINE__);
			$arTapLoginUser = $rsTapLoginUser->Fetch();
			
			if ($arTapLoginUser["AZID_ID"] != $AZID_ID)
				return false;
			else
				return true;
		}
		
		$rsIssetAzidId = $DB->query("SELECT 1 FROM b_taplogin_user WHERE AZID_ID = ".$AZID_ID, false, "File: ".__FILE__."<br>Line: ".__LINE__);
		if ($rsIssetAzidId->Fetch() != false)
			return false;
		
		$bResult = false;

		if ($DB->Query("INSERT INTO b_taplogin_user (USER_ID, AZID_ID, DATE_REGISTER) VALUES ('".$USER_ID."', '".$AZID_ID."', ".$DB->GetNowFunction().")"))
			$bResult = true;
		
		return $bResult;
	}
	
	public static function Add($arrParams)
	{
		global $DB;
		$employee_id = intval($arrParams["employee_id"]);
		
		if (!$employee_id)
			return false;
		
		$user = new CUser;
		
		$user_prefix = uniqid("tap_", true);
		
		if ($arrParams["employee_login"])
		{
			$arrIssetLogin = CUser::GetByLogin($arrParams["employee_login"])->Fetch();
			if (!empty($arrIssetLogin))
				$arrParams["employee_login"] = $arrParams["employee_login"].rand(1,5);
		}
		
		if (TapLogin::isActiveEmailGeneration() == "Y")
			$arrParams["employee_email"] = $user_prefix."@example.com";
		
		$arFields = array(
			"LOGIN" => isset($arrParams["employee_login"]) ? $arrParams["employee_login"] : $user_prefix,
			"PASSWORD" => randString(7),
			"EMAIL" => $arrParams["employee_email"]
		);
		
		$DB->StartTransaction();
		
		if ($ID = $user->Add($arFields))
		{
			$DB->Query("INSERT INTO b_taplogin_user (USER_ID, AZID_ID, DATE_REGISTER) VALUES ('".$ID."', '".$employee_id."', ".$DB->GetNowFunction().")");
			$DB->Commit();
			
			return $ID;
		}
		
		$DB->Rollback();
		return false;
	}
}

?>
